## xgboost 3.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)

if(PLUGIN_SYCL)
  string(REPLACE " -isystem ${CONDA_PREFIX}/include" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
endif()

project(xgboost LANGUAGES CXX C VERSION 3.0.4)
include(cmake/Utils.cmake)
list(APPEND CMAKE_MODULE_PATH "${xgboost_SOURCE_DIR}/cmake/modules")

# These policies are already set from 3.18 but we still need to set the policy
# default variables here for lower minimum versions in the submodules
set(CMAKE_POLICY_DEFAULT_CMP0063 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0076 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0079 NEW)

message(STATUS "CMake version ${CMAKE_VERSION}")

# Check compiler versions
# Use recent compilers to ensure that std::filesystem is available
if(MSVC)
  if(MSVC_VERSION LESS 1920)
    message(FATAL_ERROR "Need Visual Studio 2019 or newer to build XGBoost")
  endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "8.1")
    message(FATAL_ERROR "Need GCC 8.1 or newer to build XGBoost")
  endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "11.0")
    message(FATAL_ERROR "Need Xcode 11.0 (AppleClang 11.0) or newer to build XGBoost")
  endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9.0")
    message(FATAL_ERROR "Need Clang 9.0 or newer to build XGBoost")
  endif()
endif()

include(${xgboost_SOURCE_DIR}/cmake/PrefetchIntrinsics.cmake)
find_prefetch_intrinsics()
include(${xgboost_SOURCE_DIR}/cmake/Version.cmake)
write_version()
set_default_configuration_release()

#-- Options
include(CMakeDependentOption)

## User options
option(BUILD_C_DOC "Build documentation for C APIs using Doxygen." OFF)
option(USE_OPENMP "Build with OpenMP support." ON)
option(BUILD_STATIC_LIB "Build static library" OFF)
option(BUILD_DEPRECATED_CLI "Build the deprecated command line interface" OFF)
option(FORCE_SHARED_CRT "Build with dynamic CRT on Windows (/MD)" OFF)
## Bindings
option(JVM_BINDINGS "Build JVM bindings" OFF)
option(R_LIB "Build shared library for R package" OFF)
## Dev
option(USE_DEBUG_OUTPUT "Dump internal training results like gradients and predictions to stdout.
Should only be used for debugging." OFF)
option(FORCE_COLORED_OUTPUT "Force colored output from compilers, useful when ninja is used instead of make." OFF)
option(ENABLE_ALL_WARNINGS "Enable all compiler warnings. Only effective for GCC/Clang" OFF)
option(LOG_CAPI_INVOCATION "Log all C API invocations for debugging" OFF)
option(GOOGLE_TEST "Build google tests" OFF)
option(USE_DMLC_GTEST "Use google tests bundled with dmlc-core submodule" OFF)
option(USE_DEVICE_DEBUG "Generate CUDA device debug info." OFF)
option(USE_NVTX "Build with cuda profiling annotations. Developers only." OFF)
set(NVTX_HEADER_DIR "" CACHE PATH "Path to the stand-alone nvtx header")
option(HIDE_CXX_SYMBOLS "Build shared library and hide all C++ symbols" OFF)
option(KEEP_BUILD_ARTIFACTS_IN_BINARY_DIR "Output build artifacts in CMake binary dir" OFF)
## CUDA
option(USE_CUDA  "Build with GPU acceleration" OFF)
option(USE_NCCL  "Build with NCCL to enable distributed GPU support." OFF)
# This is specifically designed for PyPI binary release and should be disabled for most of the cases.
option(USE_DLOPEN_NCCL "Whether to load nccl dynamically." OFF)
option(BUILD_WITH_SHARED_NCCL "Build with shared NCCL library." OFF)

if(USE_CUDA)
  if(NOT DEFINED CMAKE_CUDA_ARCHITECTURES AND NOT DEFINED ENV{CUDAARCHS})
    set(GPU_COMPUTE_VER "" CACHE STRING
      "Semicolon separated list of compute versions to be built against, e.g. '35;61'")
  else()
    # Clear any cached values from previous runs
    unset(GPU_COMPUTE_VER)
    unset(GPU_COMPUTE_VER CACHE)
  endif()
endif()

# CUDA device LTO was introduced in CMake v3.25 and requires host LTO to also be enabled but can still
# be explicitly disabled allowing for LTO on host only, host and device, or neither, but device-only LTO
# is not a supproted configuration
cmake_dependent_option(USE_CUDA_LTO
  "Enable link-time optimization for CUDA device code"
  "${CMAKE_INTERPROCEDURAL_OPTIMIZATION}"
  "CMAKE_VERSION VERSION_GREATER_EQUAL 3.25;USE_CUDA;CMAKE_INTERPROCEDURAL_OPTIMIZATION"
  OFF)
## Sanitizers
option(USE_SANITIZER "Use santizer flags" OFF)
option(SANITIZER_PATH "Path to sanitizes.")
set(ENABLED_SANITIZERS "address" "leak" CACHE STRING
  "Semicolon separated list of sanitizer names. E.g 'address;leak'. Supported sanitizers are
address, leak, undefined and thread.")
## Plugins
option(PLUGIN_RMM "Build with RAPIDS Memory Manager (RMM)" OFF)
option(PLUGIN_FEDERATED "Build with Federated Learning" OFF)
## TODO: 1. Add check if DPC++ compiler is used for building
option(PLUGIN_SYCL "SYCL plugin" OFF)
option(ADD_PKGCONFIG "Add xgboost.pc into system." ON)

#-- Checks for building XGBoost
if(USE_DEBUG_OUTPUT AND (NOT (CMAKE_BUILD_TYPE MATCHES Debug)))
  message(SEND_ERROR "Do not enable `USE_DEBUG_OUTPUT' with release build.")
endif()
if(USE_NVTX AND (NOT USE_CUDA))
  message(SEND_ERROR "`USE_NVTX` must be enabled with `USE_CUDA` flag.")
endif()
if(USE_NVTX)
  if(CMAKE_VERSION VERSION_LESS "3.25.0")
    # CUDA:nvtx3 target is added in 3.25
    message("cmake >= 3.25 is required for NVTX.")
  endif()
endif()
if(USE_NCCL AND (NOT USE_CUDA))
  message(SEND_ERROR "`USE_NCCL` must be enabled with `USE_CUDA` flag.")
endif()
if(USE_DEVICE_DEBUG AND (NOT USE_CUDA))
  message(SEND_ERROR "`USE_DEVICE_DEBUG` must be enabled with `USE_CUDA` flag.")
endif()
if(BUILD_WITH_SHARED_NCCL AND (NOT USE_NCCL))
  message(SEND_ERROR "Build XGBoost with -DUSE_NCCL=ON to enable BUILD_WITH_SHARED_NCCL.")
endif()
if(USE_DLOPEN_NCCL AND (NOT USE_NCCL))
  message(SEND_ERROR "Build XGBoost with -DUSE_NCCL=ON to enable USE_DLOPEN_NCCL.")
endif()
if(USE_DLOPEN_NCCL AND (NOT (CMAKE_SYSTEM_NAME STREQUAL "Linux")))
  message(SEND_ERROR "`USE_DLOPEN_NCCL` supports only Linux at the moment.")
endif()
if(JVM_BINDINGS AND R_LIB)
  message(SEND_ERROR "`R_LIB' is not compatible with `JVM_BINDINGS' as they both have customized configurations.")
endif()
if(R_LIB AND GOOGLE_TEST)
  message(
    WARNING
    "Some C++ tests will fail with `R_LIB` enabled, as R package redirects some functions to R runtime implementation."
  )
endif()
if(PLUGIN_RMM AND NOT (USE_CUDA))
  message(SEND_ERROR "`PLUGIN_RMM` must be enabled with `USE_CUDA` flag.")
endif()
if(PLUGIN_RMM AND NOT ((CMAKE_CXX_COMPILER_ID STREQUAL "Clang") OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")))
  message(SEND_ERROR "`PLUGIN_RMM` must be used with GCC or Clang compiler.")
endif()
if(PLUGIN_RMM AND NOT (CMAKE_SYSTEM_NAME STREQUAL "Linux"))
  message(SEND_ERROR "`PLUGIN_RMM` must be used with Linux.")
endif()
if(ENABLE_ALL_WARNINGS)
  if((NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang") AND (NOT CMAKE_CXX_COMPILER_ID STREQUAL "GNU"))
    message(SEND_ERROR "ENABLE_ALL_WARNINGS is only available for Clang and GCC.")
  endif()
endif()
if(BUILD_STATIC_LIB AND (R_LIB OR JVM_BINDINGS))
  message(SEND_ERROR "Cannot build a static library libxgboost.a when R or JVM packages are enabled.")
endif()
if(PLUGIN_FEDERATED)
  if(CMAKE_CROSSCOMPILING)
    message(SEND_ERROR "Cannot cross compile with federated learning support")
  endif()
  if(BUILD_STATIC_LIB)
    message(SEND_ERROR "Cannot build static lib with federated learning support")
  endif()
  if(R_LIB OR JVM_BINDINGS)
    message(SEND_ERROR "Cannot enable federated learning support when R or JVM packages are enabled.")
  endif()
  if(WIN32)
    message(SEND_ERROR "Federated learning not supported for Windows platform")
  endif()
endif()

#-- Removed options
if(USE_AVX)
  message(SEND_ERROR  "The option `USE_AVX` is deprecated as experimental AVX features have been removed from XGBoost.")
endif()
if(PLUGIN_LZ4)
  message(SEND_ERROR  "The option `PLUGIN_LZ4` is removed from XGBoost.")
endif()
if(RABIT_BUILD_MPI)
  message(SEND_ERROR "The option `RABIT_BUILD_MPI` has been removed from XGBoost.")
endif()
if(USE_S3)
  message(SEND_ERROR "The option `USE_S3` has been removed from XGBoost")
endif()
if(USE_AZURE)
  message(SEND_ERROR "The option `USE_AZURE` has been removed from XGBoost")
endif()
if(USE_HDFS)
  message(SEND_ERROR "The option `USE_HDFS` has been removed from XGBoost")
endif()
if(PLUGIN_DENSE_PARSER)
  message(SEND_ERROR "The option `PLUGIN_DENSE_PARSER` has been removed from XGBoost.")
endif()

#-- Sanitizer
if(USE_SANITIZER)
  include(cmake/Sanitizer.cmake)
  enable_sanitizers("${ENABLED_SANITIZERS}")
endif()

if(USE_CUDA)
  set(USE_OPENMP ON CACHE BOOL "CUDA requires OpenMP" FORCE)
  # `export CXX=' is ignored by CMake CUDA.
  if(NOT DEFINED CMAKE_CUDA_HOST_COMPILER AND NOT DEFINED ENV{CUDAHOSTCXX})
    set(CMAKE_CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER} CACHE FILEPATH
      "The compiler executable to use when compiling host code for CUDA or HIP language files.")
    mark_as_advanced(CMAKE_CUDA_HOST_COMPILER)
    message(STATUS "Configured CUDA host compiler: ${CMAKE_CUDA_HOST_COMPILER}")
  endif()

  if(NOT DEFINED CMAKE_CUDA_RUNTIME_LIBRARY)
    set(CMAKE_CUDA_RUNTIME_LIBRARY Static)
  endif()

  enable_language(CUDA)
  if(${CMAKE_CUDA_COMPILER_VERSION} VERSION_LESS 11.0)
    message(FATAL_ERROR "CUDA version must be at least 11.0!")
  endif()
  if(DEFINED GPU_COMPUTE_VER)
    compute_cmake_cuda_archs("${GPU_COMPUTE_VER}")
  endif()

  find_package(CUDAToolkit REQUIRED)
endif()

if(FORCE_COLORED_OUTPUT AND (CMAKE_GENERATOR STREQUAL "Ninja") AND
    ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") OR
      (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")))
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fdiagnostics-color=always")
endif()

find_package(Threads REQUIRED)

# -- OpenMP
include(cmake/FindOpenMPMacOS.cmake)
if(USE_OPENMP)
  if(APPLE)
    find_openmp_macos()
  else()
    find_package(OpenMP REQUIRED)
  endif()
endif()

# Add for IBM i
if(${CMAKE_SYSTEM_NAME} MATCHES "OS400")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  set(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> -X64 qc <TARGET> <OBJECTS>")
endif()

if(USE_NCCL)
  find_package(Nccl REQUIRED)
endif()

if(MSVC)
  if(FORCE_SHARED_CRT)
    message(STATUS "XGBoost: Using dynamically linked MSVC runtime...")
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
  else()
    message(STATUS "XGBoost: Using statically linked MSVC runtime...")
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
  endif()
endif()

# dmlc-core
set(DMLC_FORCE_SHARED_CRT ${FORCE_SHARED_CRT})
add_subdirectory(${xgboost_SOURCE_DIR}/dmlc-core)

if(MSVC)
  if(TARGET dmlc_unit_tests)
    target_compile_options(
        dmlc_unit_tests PRIVATE
        -D_CRT_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_DEPRECATE
    )
  endif()
endif()

# core xgboost
add_subdirectory(${xgboost_SOURCE_DIR}/src)
target_link_libraries(objxgboost PUBLIC dmlc)

# Link -lstdc++fs for GCC 8.x
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9.0")
  target_link_libraries(objxgboost PUBLIC stdc++fs)
endif()

# Exports some R specific definitions and objects
if(R_LIB)
  add_subdirectory(${xgboost_SOURCE_DIR}/R-package)
endif()

# This creates its own shared library `xgboost4j'.
if(JVM_BINDINGS)
  add_subdirectory(${xgboost_SOURCE_DIR}/jvm-packages)
endif()

# Plugin
add_subdirectory(${xgboost_SOURCE_DIR}/plugin)

if(PLUGIN_RMM)
  find_package(rmm REQUIRED)

  # Patch the rmm targets so they reference the static cudart
  # Remove this patch once RMM stops specifying cudart requirement
  # (since RMM is a header-only library, it should not specify cudart in its CMake config)
  get_target_property(rmm_link_libs rmm::rmm INTERFACE_LINK_LIBRARIES)
  list(REMOVE_ITEM rmm_link_libs CUDA::cudart)
  list(APPEND rmm_link_libs CUDA::cudart_static)
  set_target_properties(rmm::rmm PROPERTIES INTERFACE_LINK_LIBRARIES "${rmm_link_libs}")

  # Pick up patched CCCL from RMM
elseif(USE_CUDA)

=== R-package/CMakeLists.txt ===
find_package(LibR REQUIRED)
message(STATUS "LIBR_CORE_LIBRARY " ${LIBR_CORE_LIBRARY})

file(
  GLOB_RECURSE R_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/src/*.cc
  ${CMAKE_CURRENT_LIST_DIR}/src/*.c
)

# Use object library to expose symbols
add_library(xgboost-r OBJECT ${R_SOURCES})

if(ENABLE_ALL_WARNINGS)
  target_compile_options(xgboost-r PRIVATE -Wall -Wextra)
endif()

if(MSVC)
  # https://github.com/microsoft/LightGBM/pull/6061
  # MSVC doesn't work with anonymous types in structs. (R complex)
  #
  # syntax error: missing ';' before identifier 'private_data_c'
  #
  target_compile_definitions(xgboost-r PRIVATE -DR_LEGACY_RCOMPLEX)
endif()

target_compile_definitions(
  xgboost-r PUBLIC
  -DXGBOOST_STRICT_R_MODE=1
  -DDMLC_LOG_BEFORE_THROW=0
  -DDMLC_DISABLE_STDIN=1
  -DDMLC_LOG_CUSTOMIZE=1
)

target_include_directories(
  xgboost-r PRIVATE
  ${LIBR_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_SOURCE_DIR}/dmlc-core/include
)

target_link_libraries(xgboost-r PUBLIC ${LIBR_CORE_LIBRARY})

if(USE_OPENMP)
  find_package(OpenMP REQUIRED)
  target_link_libraries(xgboost-r PUBLIC OpenMP::OpenMP_CXX OpenMP::OpenMP_C)
endif()

set_target_properties(
  xgboost-r PROPERTIES
  CXX_STANDARD 17
  CXX_STANDARD_REQUIRED ON
  POSITION_INDEPENDENT_CODE ON
)

# Get compilation and link flags of xgboost-r and propagate to objxgboost
target_link_libraries(objxgboost PUBLIC xgboost-r)

# Add all objects of xgboost-r to objxgboost
target_sources(objxgboost INTERFACE $<TARGET_OBJECTS:xgboost-r>)

set(LIBR_HOME "${LIBR_HOME}" PARENT_SCOPE)
set(LIBR_EXECUTABLE "${LIBR_EXECUTABLE}" PARENT_SCOPE)

=== R-package/DESCRIPTION ===
Package: xgboost
Type: Package
Title: Extreme Gradient Boosting
Version: 3.0.4.1
Date: 2025-08-11
Authors@R: c(
  person("Tianqi", "Chen", role = c("aut"),
         email = "tianqi.tchen@gmail.com"),
  person("Tong", "He", role = c("aut"),
         email = "hetong007@gmail.com"),
  person("Michael", "Benesty", role = c("aut"),
         email = "michael@benesty.fr"),
  person("Vadim", "Khotilovich", role = c("aut"),
         email = "khotilovich@gmail.com"),
  person("Yuan", "Tang", role = c("aut"),
         email = "terrytangyuan@gmail.com",
         comment = c(ORCID = "0000-0001-5243-233X")),
  person("Hyunsu", "Cho", role = c("aut"),
         email = "chohyu01@cs.washington.edu"),
  person("Kailong", "Chen", role = c("aut")),
  person("Rory", "Mitchell", role = c("aut")),
  person("Ignacio", "Cano", role = c("aut")),
  person("Tianyi", "Zhou", role = c("aut")),
  person("Mu", "Li", role = c("aut")),
  person("Junyuan", "Xie", role = c("aut")),
  person("Min", "Lin", role = c("aut")),
  person("Yifeng", "Geng", role = c("aut")),
  person("Yutian", "Li", role = c("aut")),
  person("Jiaming", "Yuan", role = c("aut", "cre"),
         email = "jm.yuan@outlook.com"),
  person("David", "Cortes", role = c("aut")),
  person("XGBoost contributors", role = c("cph"),
         comment = "base XGBoost implementation")
  )
Maintainer: Jiaming Yuan <jm.yuan@outlook.com>
Description: Extreme Gradient Boosting, which is an efficient implementation
    of the gradient boosting framework from Chen & Guestrin (2016) <doi:10.1145/2939672.2939785>.
    This package is its R interface. The package includes efficient linear
    model solver and tree learning algorithms. The package can automatically
    do parallel computation on a single machine which could be more than 10
    times faster than existing gradient boosting packages. It supports
    various objective functions, including regression, classification and ranking.
    The package is made to be extensible, so that users are also allowed to define
    their own objectives easily.
License: Apache License (== 2.0) | file LICENSE
URL: https://github.com/dmlc/xgboost
BugReports: https://github.com/dmlc/xgboost/issues
NeedsCompilation: yes
VignetteBuilder: knitr
Suggests:
    knitr,
    rmarkdown,
    ggplot2 (>= 1.0.1),
    DiagrammeR (>= 0.9.0),
    DiagrammeRsvg,
    rsvg,
    htmlwidgets,
    Ckmeans.1d.dp (>= 3.3.1),
    vcd (>= 1.3),
    testthat,
    igraph (>= 1.0.1),
    float,
    titanic,
    RhpcBLASctl,
    survival
Depends:
    R (>= 4.3.0)
Imports:
    Matrix (>= 1.1-0),
    methods,
    data.table (>= 1.9.6),
    jsonlite (>= 1.0)
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
Encoding: UTF-8
SystemRequirements: GNU make, C++17

=== doc/requirements.txt ===
sphinx
mock
sphinx_rtd_theme>=1.0.0
breathe
scikit-learn
sh
matplotlib
graphviz
numpy
scipy
myst-parser
ray[train]
sphinx-gallery
dask
pyspark
cloudpickle
setuptools

=== jvm-packages/CMakeLists.txt ===
find_package(JNI REQUIRED)

list(APPEND JVM_SOURCES
  ${PROJECT_SOURCE_DIR}/jvm-packages/xgboost4j/src/native/xgboost4j.cpp
  ${PROJECT_SOURCE_DIR}/jvm-packages/xgboost4j/src/native/xgboost4j-gpu.cpp)

if(USE_CUDA)
  list(APPEND JVM_SOURCES
    ${PROJECT_SOURCE_DIR}/jvm-packages/xgboost4j/src/native/xgboost4j-gpu.cu)
endif()

add_library(xgboost4j SHARED ${JVM_SOURCES} ${XGBOOST_OBJ_SOURCES})

if(ENABLE_ALL_WARNINGS)
  target_compile_options(xgboost4j PUBLIC -Wall -Wextra)
endif()

target_link_libraries(xgboost4j PRIVATE objxgboost)
target_include_directories(xgboost4j
  PRIVATE
  ${JNI_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/jvm-packages/xgboost4j/src/native
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_SOURCE_DIR}/dmlc-core/include)

set_output_directory(xgboost4j ${PROJECT_SOURCE_DIR}/lib)

# MacOS: Patch libxgboost4j.dylib to use @rpath/libomp.dylib
if(USE_OPENMP AND APPLE)
  patch_openmp_path_macos(xgboost4j libxgboost4j)
endif()

=== plugin/CMakeLists.txt ===
if(PLUGIN_SYCL)
  set(CMAKE_CXX_COMPILER "icpx")
  file(GLOB_RECURSE SYCL_SOURCES "sycl/*.cc")
    list(APPEND SYCL_SOURCES
    ${xgboost_SOURCE_DIR}/src/objective/regression_obj.cc
    ${xgboost_SOURCE_DIR}/src/objective/hinge.cc
    ${xgboost_SOURCE_DIR}/src/objective/quantile_obj.cc
    ${xgboost_SOURCE_DIR}/src/objective/multiclass_obj.cc)
  add_library(plugin_sycl OBJECT ${SYCL_SOURCES})
  target_include_directories(plugin_sycl
    PRIVATE
    ${xgboost_SOURCE_DIR}/include
    ${xgboost_SOURCE_DIR}/dmlc-core/include
    ${xgboost_SOURCE_DIR}/rabit/include)
    target_compile_definitions(plugin_sycl PUBLIC -DXGBOOST_USE_SYCL=1)
    target_link_libraries(plugin_sycl PUBLIC -fsycl)
    set_target_properties(plugin_sycl PROPERTIES
    COMPILE_FLAGS "-fsycl -fno-sycl-id-queries-fit-in-int"
    CXX_STANDARD 17
    CXX_STANDARD_REQUIRED ON
    POSITION_INDEPENDENT_CODE ON)
  if(USE_OPENMP)
    find_package(OpenMP REQUIRED)
    set_target_properties(plugin_sycl PROPERTIES
    COMPILE_FLAGS "-fsycl -fno-sycl-id-queries-fit-in-int -qopenmp")
  endif()
  # Get compilation and link flags of plugin_sycl and propagate to objxgboost
  target_link_libraries(objxgboost PUBLIC plugin_sycl)
  # Add all objects of plugin_sycl to objxgboost
  target_sources(objxgboost INTERFACE $<TARGET_OBJECTS:plugin_sycl>)
endif()

# Add the Federate Learning plugin if enabled.
if(PLUGIN_FEDERATED)
  add_subdirectory(federated)
endif()

=== demo/c-api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
project(xgboost-c-examples)

add_subdirectory(basic)
add_subdirectory(external-memory)
add_subdirectory(inference)

enable_testing()
add_test(
  NAME test_xgboost_demo_c_basic
  COMMAND api-demo
  WORKING_DIRECTORY ${xgboost-c-examples_BINARY_DIR}
)
add_test(
  NAME test_xgboost_demo_c_external_memory
  COMMAND external-memory-demo
  WORKING_DIRECTORY ${xgboost-c-examples_BINARY_DIR}
)
add_test(
  NAME test_xgboost_demo_c_inference
  COMMAND inference-demo
  WORKING_DIRECTORY ${xgboost-c-examples_BINARY_DIR}
)

=== doc/R-package/Makefile ===
# This is the makefile for compiling Rmarkdown files into the md file with results.
PKGROOT=../../R-package

# ADD The Markdown to be built here, with suffix md
xgboostfromJSON.md: $(PKGROOT)/vignettes/xgboostfromJSON.Rmd
xgboost_introduction.md: $(PKGROOT)/vignettes/xgboost_introduction.Rmd

all: xgboostfromJSON.md xgboost_introduction.md

# General Rules for build rmarkdowns, need knitr
%.md:
	Rscript -e \
	"require(methods);"\
	"require(knitr);"\
	"knitr::opts_knit\$$set(root.dir=\".\");"\
	"knitr::opts_chunk\$$set(fig.path=\"../web-data/xgboost/knitr/$(basename $@)-\");"\
	"knitr::knit(\"$+\")"

=== tests/cpp/CMakeLists.txt ===
# The testxgboost executable is created in the top level CMakeLists. Most of the
# properties and compilation flags are already set. We just need to add source files and
# link gtest here.
if(USE_DMLC_GTEST)
  if(NOT TARGET gtest)
    message(FATAL_ERROR "USE_DMLC_GTEST=ON but dmlc-core didn't bundle gtest")
  endif()
  set(GTEST_LIBRARIES gtest gmock)
else()
  find_package(GTest REQUIRED)
endif()

file(GLOB_RECURSE TEST_SOURCES "*.cc")

if(USE_CUDA)
  file(GLOB_RECURSE CUDA_TEST_SOURCES "*.cu")
  list(APPEND TEST_SOURCES ${CUDA_TEST_SOURCES})
endif()

# We will add them back later to separate the definition.
file(GLOB_RECURSE FEDERATED_TEST_SOURCES "plugin/federated/*.*")
list(REMOVE_ITEM TEST_SOURCES ${FEDERATED_TEST_SOURCES})

file(GLOB_RECURSE SYCL_TEST_SOURCES "plugin/test_sycl_*.cc")
list(REMOVE_ITEM TEST_SOURCES ${SYCL_TEST_SOURCES})

if(PLUGIN_SYCL)
  set(CMAKE_CXX_COMPILER "icpx")
  file(GLOB_RECURSE SYCL_TEST_SOURCES "plugin/test_sycl_*.cc")
  add_library(plugin_sycl_test OBJECT ${SYCL_TEST_SOURCES})

  target_include_directories(plugin_sycl_test
    PRIVATE
    ${gtest_SOURCE_DIR}/include
    ${xgboost_SOURCE_DIR}/include
    ${xgboost_SOURCE_DIR}/dmlc-core/include)

  target_compile_definitions(plugin_sycl_test PUBLIC -DXGBOOST_USE_SYCL=1)
  target_link_libraries(plugin_sycl_test PUBLIC -fsycl)
  target_link_libraries(plugin_sycl_test PRIVATE ${GTEST_LIBRARIES})

  set_target_properties(plugin_sycl_test PROPERTIES
    COMPILE_FLAGS -fsycl
    CXX_STANDARD 17
    CXX_STANDARD_REQUIRED ON
    POSITION_INDEPENDENT_CODE ON)
  if(USE_OPENMP)
    find_package(OpenMP REQUIRED)
    set_target_properties(plugin_sycl_test PROPERTIES
    COMPILE_FLAGS "-fsycl -qopenmp")
  endif()
  # Get compilation and link flags of plugin_sycl and propagate to testxgboost
  target_link_libraries(testxgboost PUBLIC plugin_sycl_test)
  # Add all objects of plugin_sycl to testxgboost
  target_sources(testxgboost INTERFACE $<TARGET_OBJECTS:plugin_sycl_test>)
endif()

if(PLUGIN_FEDERATED)
  add_subdirectory(${xgboost_SOURCE_DIR}/tests/cpp/plugin/federated)
endif()

target_sources(
  testxgboost PRIVATE
  ${TEST_SOURCES}
  ${xgboost_SOURCE_DIR}/plugin/example/custom_obj.cc
)

if(USE_CUDA AND PLUGIN_RMM)
  target_include_directories(testxgboost PRIVATE ${CUDA_INCLUDE_DIRS})
endif()

target_include_directories(testxgboost
  PRIVATE
  ${xgboost_SOURCE_DIR}/include
  ${xgboost_SOURCE_DIR}/dmlc-core/include)
target_link_libraries(testxgboost
  PRIVATE
  $<TARGET_NAME_IF_EXISTS:rmm::rmm_logger>
  $<TARGET_NAME_IF_EXISTS:rmm::rmm_logger_impl>
  GTest::gtest GTest::gmock)

set_output_directory(testxgboost ${xgboost_BINARY_DIR})

# This grouping organises source files nicely in visual studio
auto_source_group("${TEST_SOURCES}")

=== demo/c-api/basic/CMakeLists.txt ===
project(api-demo LANGUAGES C VERSION 0.0.1)
find_package(xgboost REQUIRED)

# xgboost is built as static libraries, all cxx dependencies need to be linked into the
# executable.
if(XGBOOST_BUILD_STATIC_LIB)
  enable_language(CXX)
  # find again for those  cxx libraries.
  find_package(xgboost REQUIRED)
endif()

add_executable(api-demo c-api-demo.c)
target_link_libraries(api-demo PRIVATE xgboost::xgboost)

=== demo/c-api/basic/Makefile ===
SRC=c-api-demo.c
TGT=c-api-demo

cc=cc
CFLAGS ?=-O3
XGBOOST_ROOT ?=../..
INCLUDE_DIR=-I$(XGBOOST_ROOT)/include -I$(XGBOOST_ROOT)/dmlc-core/include
LIB_DIR=-L$(XGBOOST_ROOT)/lib

build: $(TGT)

$(TGT): $(SRC) Makefile
	$(cc) $(CFLAGS) $(INCLUDE_DIR) $(LIB_DIR) -o $(TGT) $(SRC) -lxgboost

run: $(TGT)
	LD_LIBRARY_PATH=$(XGBOOST_ROOT)/lib ./$(TGT)

clean:
	rm -f $(TGT)

=== demo/c-api/external-memory/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
project(external-memory-demo LANGUAGES C VERSION 0.0.1)

find_package(xgboost REQUIRED)

add_executable(external-memory-demo external_memory.c)
target_link_libraries(external-memory-demo PRIVATE xgboost::xgboost)

=== debian/changelog ===
xgboost (3.0.4-1) unstable; urgency=medium

  [ Kentaro Hayashi ]
  * Use d/watch 5

  [ Mo Zhou ]
  * New upstream version 3.0.4

 -- Mo Zhou <lumin@debian.org>  Fri, 15 Aug 2025 11:37:13 -0400

=== debian/control ===
Source: xgboost
Section: science
Homepage: https://xgboost.ai/
Priority: optional
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/xgboost.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/xgboost
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libdmlc-dev (>= 0.5+git20240614.1334185~),
               ninja-build,
               pybuild-plugin-pyproject,
               python3-all,
               python3-hatchling,
               python3-setuptools
#               nvidia-cuda-toolkit,
#               nvidia-cuda-toolkit-gcc,
#               libnccl-dev,
#               libcub-dev,

Package: libxgboost-dev
Section: libdevel
Architecture: any
Depends: libxgboost0 (= ${binary:Version}), ${misc:Depends}
Description: Scalable and Flexible Gradient Boosting (Development)
 XGBoost is an optimized distributed gradient boosting library designed to be
 highly efficient, flexible and portable. It implements machine learning
 algorithms under the Gradient Boosting framework. XGBoost provides a parallel
 tree boosting (also known as GBDT, GBM) that solve many data science problems
 in a fast and accurate way. The same code runs on major distributed environment
 (Kubernetes, Hadoop, SGE, MPI, Dask) and can solve problems beyond billions of
 examples.
 .
 This package contains the xgboost development files.

Package: libxgboost0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Scalable and Flexible Gradient Boosting (Shared lib)
 XGBoost is an optimized distributed gradient boosting library designed to be
 highly efficient, flexible and portable. It implements machine learning
 algorithms under the Gradient Boosting framework. XGBoost provides a parallel
 tree boosting (also known as GBDT, GBM) that solve many data science problems
 in a fast and accurate way. The same code runs on major distributed environment
 (Kubernetes, Hadoop, SGE, MPI, Dask) and can solve problems beyond billions of
 examples.
 .
 This package contains the xgboost shared object.

Package: python3-xgboost
Section: python
Architecture: any
Depends: libxgboost0 (= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
Suggests: python3-sklearn
Description: Scalable and Flexible Gradient Boosting (Python3)
 XGBoost is an optimized distributed gradient boosting library designed to be
 highly efficient, flexible and portable. It implements machine learning
 algorithms under the Gradient Boosting framework. XGBoost provides a parallel
 tree boosting (also known as GBDT, GBM) that solve many data science problems
 in a fast and accurate way. The same code runs on major distributed environment
 (Kubernetes, Hadoop, SGE, MPI, Dask) and can solve problems beyond billions of
 examples.
 .
 This package contains the xgboost python3 binding.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
export PYBUILD_NAME=xgboost
#export CC=cuda-gcc
#export CXX=cuda-g++

%:
	dh $@ -Scmake+ninja --with python3

#execute_before_dh_auto_configure:
#	cp -rv debian/gputreeshap $(CURDIR)
#	# patch the cmake file
#	sed -e '20,$$d' -i gputreeshap/CMakeLists.txt

#override_dh_auto_configure:
#	dh_auto_configure -- \
#		-DUSE_CUDA=ON -DBUILD_WITH_CUDA_CUB=ON -DUSE_NCCL=ON

override_dh_auto_test:
# upstream ctest is not enabled because many tests require network
	true

execute_after_dh_auto_configure:
	dh_auto_configure -Spybuild -- -d python-package/ --system=pyproject

execute_after_dh_auto_build:
	dh_auto_build -Spybuild -- -d python-package/ --system=pyproject

execute_after_dh_auto_install:
	dh_auto_install -Spybuild -- -d python-package/ --system=pyproject
	mkdir -p debian/tmp/usr/lib/python3/dist-packages/xgboost/lib/
	ln -s ../../../../$(DEB_HOST_MULTIARCH)/libxgboost.so.0 \
	   debian/tmp/usr/lib/python3/dist-packages/xgboost/lib/libxgboost.so

execute_after_dh_auto_clean:
	dh_auto_clean -Spybuild -- -d python-package/ --system=pyproject
	-$(RM) xgboost
	-$(RM) -rf lib

override_dh_python3:
	dh_python3
	-$(RM) debian/tmp/usr/lib/python3/dist-packages/xgboost/lib/libxgboost.cpy*
	-$(RM) debian/python3-xgboost/usr/lib/python3/dist-packages/xgboost/lib/libxgboost.cpy*

=== debian/tests/control ===
Tests: run-demos
Depends: bash,
         python3-matplotlib,
         python3-numpy,
         python3-pandas,
         python3-scipy,
         python3-sklearn,
         ca-certificates,
         @
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Source: https://github.com/dmlc/xgboost/tags
Matching-Pattern: (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%xgboost-$1.tar.gz%
Update-Script: uupdate

## xgboost 3.1.2.1

=== DESCRIPTION ===
Package: xgboost
Type: Package
Title: Extreme Gradient Boosting
Version: 3.1.2.1
Date: 2025-11-20
Authors@R: c(
  person("Tianqi", "Chen", role = c("aut"),
         email = "tianqi.tchen@gmail.com"),
  person("Tong", "He", role = c("aut"),
         email = "hetong007@gmail.com"),
  person("Michael", "Benesty", role = c("aut"),
         email = "michael@benesty.fr"),
  person("Vadim", "Khotilovich", role = c("aut"),
         email = "khotilovich@gmail.com"),
  person("Yuan", "Tang", role = c("aut"),
         email = "terrytangyuan@gmail.com",
         comment = c(ORCID = "0000-0001-5243-233X")),
  person("Hyunsu", "Cho", role = c("aut"),
         email = "chohyu01@cs.washington.edu"),
  person("Kailong", "Chen", role = c("aut")),
  person("Rory", "Mitchell", role = c("aut")),
  person("Ignacio", "Cano", role = c("aut")),
  person("Tianyi", "Zhou", role = c("aut")),
  person("Mu", "Li", role = c("aut")),
  person("Junyuan", "Xie", role = c("aut")),
  person("Min", "Lin", role = c("aut")),
  person("Yifeng", "Geng", role = c("aut")),
  person("Yutian", "Li", role = c("aut")),
  person("Jiaming", "Yuan", role = c("aut", "cre"),
         email = "jm.yuan@outlook.com"),
  person("David", "Cortes", role = c("aut")),
  person("XGBoost contributors", role = c("cph"),
         comment = "base XGBoost implementation")
  )
Maintainer: Jiaming Yuan <jm.yuan@outlook.com>
Description: Extreme Gradient Boosting, which is an efficient implementation
    of the gradient boosting framework from Chen & Guestrin (2016) <doi:10.1145/2939672.2939785>.
    This package is its R interface. The package includes efficient linear
    model solver and tree learning algorithms. The package can automatically
    do parallel computation on a single machine which could be more than 10
    times faster than existing gradient boosting packages. It supports
    various objective functions, including regression, classification and ranking.
    The package is made to be extensible, so that users are also allowed to define
    their own objectives easily.
License: Apache License (== 2.0) | file LICENSE
URL: https://github.com/dmlc/xgboost
BugReports: https://github.com/dmlc/xgboost/issues
NeedsCompilation: yes
VignetteBuilder: knitr
Suggests: knitr, rmarkdown, ggplot2 (>= 1.0.1), DiagrammeR (>= 0.9.0),
        DiagrammeRsvg, rsvg, htmlwidgets, Ckmeans.1d.dp (>= 3.3.1), vcd
        (>= 1.3), testthat, igraph (>= 1.0.1), float, titanic,
        RhpcBLASctl, survival
Depends: R (>= 4.3.0)
Imports: Matrix (>= 1.1-0), methods, data.table (>= 1.9.6), jsonlite
        (>= 1.0)
RoxygenNote: 7.3.3
Encoding: UTF-8
SystemRequirements: GNU make, C++17
Packaged: 2025-12-01 18:35:59 UTC; jiamingy
Author: Tianqi Chen [aut],
  Tong He [aut],
  Michael Benesty [aut],
  Vadim Khotilovich [aut],
  Yuan Tang [aut] (ORCID: <https://orcid.org/0000-0001-5243-233X>),
  Hyunsu Cho [aut],
  Kailong Chen [aut],
  Rory Mitchell [aut],
  Ignacio Cano [aut],
  Tianyi Zhou [aut],
  Mu Li [aut],
  Junyuan Xie [aut],
  Min Lin [aut],
  Yifeng Geng [aut],
  Yutian Li [aut],
  Jiaming Yuan [aut, cre],
  David Cortes [aut],
  XGBoost contributors [cph] (base XGBoost implementation)
Repository: CRAN
Date/Publication: 2025-12-03 10:00:02 UTC

## xgboost 3.1.3.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 3.1.2.1
-Date: 2025-11-20
+Version: 3.1.3.1
+Date: 2026-01-05
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -57,7 +57,7 @@
 RoxygenNote: 7.3.3
 Encoding: UTF-8
 SystemRequirements: GNU make, C++17
-Packaged: 2025-12-01 18:35:59 UTC; jiamingy
+Packaged: 2026-01-12 05:41:41 UTC; jiamingy
 Author: Tianqi Chen [aut],
   Tong He [aut],
   Michael Benesty [aut],
@@ -77,4 +77,4 @@
   David Cortes [aut],
   XGBoost contributors [cph] (base XGBoost implementation)
 Repository: CRAN
-Date/Publication: 2025-12-03 10:00:02 UTC
+Date/Publication: 2026-01-12 08:10:02 UTC

## xgboost 3.2.0.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 3.1.3.1
-Date: 2026-01-05
+Version: 3.2.0.1
+Date: 2026-02-10
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -57,7 +57,7 @@
 RoxygenNote: 7.3.3
 Encoding: UTF-8
 SystemRequirements: GNU make, C++17
-Packaged: 2026-01-12 05:41:41 UTC; jiamingy
+Packaged: 2026-02-10 12:02:10 UTC; jiamingy
 Author: Tianqi Chen [aut],
   Tong He [aut],
   Michael Benesty [aut],
@@ -77,4 +77,4 @@
   David Cortes [aut],
   XGBoost contributors [cph] (base XGBoost implementation)
 Repository: CRAN
-Date/Publication: 2026-01-12 08:10:02 UTC
+Date/Publication: 2026-02-10 14:00:02 UTC

=== src/src/CMakeLists.txt ===
file(GLOB_RECURSE CPU_SOURCES *.cc *.h)
list(REMOVE_ITEM CPU_SOURCES ${xgboost_SOURCE_DIR}/src/cli_main.cc)

if(PLUGIN_SYCL)
  list(REMOVE_ITEM CPU_SOURCES ${xgboost_SOURCE_DIR}/src/objective/regression_obj.cc)
  list(REMOVE_ITEM CPU_SOURCES ${xgboost_SOURCE_DIR}/src/objective/hinge.cc)
  list(REMOVE_ITEM CPU_SOURCES ${xgboost_SOURCE_DIR}/src/objective/quantile_obj.cc)
  list(REMOVE_ITEM CPU_SOURCES ${xgboost_SOURCE_DIR}/src/objective/multiclass_obj.cc)
endif()

#-- Object library
# Object library is necessary for jvm-package, which creates its own shared library.
add_library(objxgboost OBJECT)
target_sources(objxgboost PRIVATE ${CPU_SOURCES})
# Skip files with factory object
set_source_files_properties(
  predictor/predictor.cc gbm/gbm.cc tree/tree_updater.cc metric/metric.cc objective/objective.cc
  PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)

if(USE_CUDA)
  file(GLOB_RECURSE CUDA_SOURCES *.cu)
  target_sources(objxgboost PRIVATE ${CUDA_SOURCES})
endif()

if(PLUGIN_SYCL)
  target_compile_definitions(objxgboost PRIVATE -DXGBOOST_USE_SYCL=1)
endif()

target_include_directories(objxgboost
  PRIVATE
  ${xgboost_SOURCE_DIR}/include
  ${xgboost_SOURCE_DIR}/dmlc-core/include)

if(LOG_CAPI_INVOCATION)
  target_compile_definitions(objxgboost PRIVATE -DLOG_CAPI_INVOCATION=1)
endif()

# This grouping organises source files nicely in visual studio
auto_source_group("${CUDA_SOURCES}")
auto_source_group("${CPU_SOURCES}")

#-- End object library
